SystemOrganization addCategory: #Moose2Model!
SystemOrganization addCategory: #'Moose2Model-Frontend'!
SystemOrganization addCategory: #'Moose2Model-Help'!
SystemOrganization addCategory: #'Moose2Model-Mocks'!
SystemOrganization addCategory: #'Moose2Model-Test'!

!FAMIXClass class methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelName
	^self name! !

!FAMIXClass methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelName
	^self name! !

!FAMIXClass methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelRemoveSuppress
	<menuItem: 'Remove suppress' category: 'Moose2Model'>
	RWDiagram suppressWithChildren: false to: self! !

!FAMIXClass methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelSuppress
	<menuItem: 'Suppress' category: 'Moose2Model'>
	RWDiagram suppressWithChildren: true to: self! !

!FAMIXType methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
javaPackage
	| stream string re pname |
	"Required when models from JAVA application are analyzed where parentPackage is empty"
	stream := '' writeStream.
	self container
		ifNotNil: [ self container mooseNameOn: stream.
			string := stream contents.
			re := '\:\:' asRegex.
			pname := re copy: string replacingMatchesWith: '.' ]
		ifNil: [ ^ nil ].
	^ FAMIXPackage new name: pname! !

!FAMIXType methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
m2mParentPackage
	"Required when models from JAVA application are analyzed where parentPackage is empty"

	self parentPackage ifNil: [ ^ self javaPackage ] ifNotNil: [ ^ parentPackage ]! !

ComposableModel subclass: #M2MFrontend
	instanceVariableNames: 'list menu pane factory new rtView myTitle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose2Model-Frontend'!

!M2MFrontend commentStamp: 'RainerWinkler 8/2/2019 15:38' prior: 0!
I represent the central part of the Frontend.
I contain the the main Spec components.
!

!M2MFrontend class methodsFor: 'specs' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
defaultSpec
	<spec: #default>
	^ SpecColumnLayout composed
		add: #menu height: self toolbarHeight; 
			"withConstraints: [ :constraints | constraints height: self toolbarHeight ];"
		add:
			(SpecRowLayout composed
				"position: 200;"
				add: #pane;
				yourself);
		yourself
	"^ SpecBoxLayout newVertical
		add: #menu
			withConstraints: [ :constraints | constraints height: self toolbarHeight ];
		add:
			(SpecPanedLayout newHorizontal
				position: 200;
				add: #list;
				add: #pane;
				yourself);
		yourself"! !

!M2MFrontend methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
changeMyTitle: item
	self window title: item! !

!M2MFrontend methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
draw2: aString
	| shape |
	shape := TRBoxShape new size: 40.
	"self makeDraggable: shape."
	self
		makeDraggable: shape
		pane: pane.
	aString = 'Green'
		ifTrue: [ shape color: Color green.
			shape position: 10 @ 10 ].
	aString = 'Red'
		ifTrue: [ shape color: Color red ].
	aString = 'ChooseColor'
		ifTrue: [ | dialog |
			dialog := self factory colorChooser title: 'Choose color'.
			dialog selectedColor: Color black.
			dialog openModal.
			shape color: dialog selectedColor.
			shape position: 5 @ 5 ].
	pane widget trachelCanvas addShape: shape.
	"Required so that the changed drawing is shown"
	pane widget changed! !

!M2MFrontend methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
factory
	^ factory! !

!M2MFrontend methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
initialize
   super initialize. 
	factory := M2MFactory new.
	myTitle = 'Moose2Model'! !

!M2MFrontend methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
initializePresenter
	"whenSelectionChangedDo:"
"In Pharo 7: whenSelectionChangedDo:"
	list
		whenSelectionChanged:  [ :item | 
			self draw2: item.
			self changeMyTitle: item	 ]
			
		"	list
		whenSelectionChanged:  [ :selection | 
			[ :item | 
			self draw2: item.
			self changeMyTitle: item	 ]
			
				cull: selection selectedItem ]"! !

!M2MFrontend methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
initializeWidgets
	| windowMorph tRcanvas|
	rtView ifNil:[
	rtView := RTView new. rtView add: (RTLabel elementOn: 'Hello World').].
	
	"tRcanvas := TRCanvas new.
	self makeZoomable: tRcanvas.
	self makeCanvasDraggable: tRcanvas."

	"tRcanvas addShape: (TRBoxShape new size: 2)."
	windowMorph := TRMorph new.
	windowMorph canvas: rtView canvas.
	pane := windowMorph asSpecAdapter.
	pane
		when: MorphOpened
		do: [ 
	windowMorph hResizing: #spaceFill.
	windowMorph vResizing: #spaceFill.
			"windowMorph extent: windowMorph extent asIntegerPoint."
			windowMorph changed ].
	pane widget surface
		drawDuring:
			[ :canvas | "First, we clear the surface" "view widget surface clear." "we can use " pane widget surface clear: Color white ].
	pane changed.
	menu := self mainMenu.
	list := self newList.
	list items: {'Green' . 'Red'}.
	self focusOrder add: list! !

!M2MFrontend methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
list
		^ list! !

!M2MFrontend methodsFor: 'accessing' stamp: 'RainerWinkler 12/18/2020 14:10'!
mainMenu
	| aMenu |
	aMenu := MenuModel new"Pharo 7 : self newMenuBar"
		addGroup: [ :group | 
			group
				addItem: [ :item | 
					item
						name: nil;
						description: 'Open Help';
						icon: ( Smalltalk ui icons iconNamed: #help "Replace in Pharo 7 with: self iconNamed:");
						action: [ HelpBrowser openOn: M2MHelp ] ] ].";"

		" addGroup: [ :group | 
			group
				addItem: [ :item | 
					item
						name: nil;
						description: 'Green';
						icon: (Smalltalk ui icons iconNamed: #glamorousGreenCircle);
						action: [ self draw2: #Green ] ] ];"
		"addGroup: [ :group | 
			group
				addItem: [ :item | 
					item
						name: nil;
						description: 'Red';
						icon: (Smalltalk ui icons iconNamed: #glamorousRedCircle);
						action: [ self draw2: #Red ] ] ];"
		"addGroup: [ :group | 
			group
				addItem: [ :item | 
					item
						name: nil;
						description: 'White';
						icon: (Smalltalk ui icons iconNamed: #glamorousAdd);
						action: [ self draw2: #ChooseColor ] ] ]."
	^ aMenu! !

!M2MFrontend methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
makeCanvasDraggable: aCanvas
	"See class RTDraggableView how this is done
This makes it possible to dragg the pane with the mouse "

	aCanvas
		when: TRMouseDragging
		do: [ :e | 
			aCanvas camera translateBy: e step negated / aCanvas camera scale.
			pane widget changed ]! !

!M2MFrontend methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
makeDraggable: aShape pane: aPane
	"Make element draggable. See class RTDraggableView how this works in prinziple."

	aShape
		when: TRMouseDragging
		do: [ :e | 
			aShape translateBy: e step / aPane widget trachelCanvas camera scale.
			aPane widget changed ]! !

!M2MFrontend methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
makeZoomable: aCanvas
	"See class RTZoomableView how this is done
This makes it possible to scroll with the mouse wheel"

	| maxZoom minZoom |
	maxZoom := 10.
	minZoom := 0.1.
	aCanvas
		when: TRMouseWheelEvent
		do: [ :e | 
			| scale dist |
			dist := e position - aCanvas camera position.
			scale := aCanvas camera scale.
			(e isUp and: [ scale * 1.25 <= maxZoom ])
				ifTrue: [ scale := scale * 1.25.
					dist := dist * 0.2 ]
				ifFalse: [ dist := 0 ].
			(e isDown and: [ scale * 0.8 >= minZoom ])
				ifTrue: [ scale := scale * 0.8.
					dist := dist * -0.25 ]
				ifFalse: [ dist := 0 ].
			aCanvas camera
				scale: scale;
				translateBy: dist.
			"aCanvas signalUpdate."
			pane widget changed ]! !

!M2MFrontend methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
menu
	^ menu! !

!M2MFrontend methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
pane
	^ pane! !

!M2MFrontend methodsFor: 'refreshing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
refresh
	"pane widget resize"! !

!M2MFrontend methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
rtView
	^ rtView! !

!M2MFrontend methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
rtView: aRTView mooseModel: aMooseModel
|windowMorph|
   myTitle := ( RWDiagramEditor uniqueInstance currentLayoutName ) , ' - ' , aMooseModel name.
	rtView := aRTView.
	
	windowMorph := TRMorph new.
	windowMorph canvas: rtView view canvas.
	windowMorph hResizing: #spaceFill.
	windowMorph vResizing: #spaceFill.
	windowMorph changed.
	pane := windowMorph asSpecAdapter.
	pane changed! !

!M2MFrontend methodsFor: 'api' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
title
	^ myTitle! !

!M2MFrontend methodsFor: 'api-events' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
whenSelectedItemChanged: aBlock
		list whenSelectedItemChanged: aBlock! !

ComposableModel subclass: #M2MFrontendDemo
	instanceVariableNames: 'list menu pane factory new'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose2Model-Frontend'!

!M2MFrontendDemo commentStamp: 'RainerWinkler 8/2/2019 15:38' prior: 0!
I represent the central part of the Frontend.
I contain the the main Spec components.
!

!M2MFrontendDemo class methodsFor: 'specs' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
defaultSpec
	<spec: #default>
	^ SpecColumnLayout composed
		add: #menu height: self toolbarHeight; 
			"withConstraints: [ :constraints | constraints height: self toolbarHeight ];"
		add:
			(SpecRowLayout composed
				"position: 200;"
				add: #list;
				addSplitter;
				add: #pane;
				yourself);
		yourself
	"^ SpecBoxLayout newVertical
		add: #menu
			withConstraints: [ :constraints | constraints height: self toolbarHeight ];
		add:
			(SpecPanedLayout newHorizontal
				position: 200;
				add: #list;
				add: #pane;
				yourself);
		yourself"! !

!M2MFrontendDemo methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
changeMyTitle: item
	self window title: item! !

!M2MFrontendDemo methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
draw2: aString
	| shape |
	shape := TRBoxShape new size: 40.
	"self makeDraggable: shape."
	self
		makeDraggable: shape
		pane: pane.
	aString = 'Green'
		ifTrue: [ shape color: Color green.
			shape position: 10 @ 10 ].
	aString = 'Red'
		ifTrue: [ shape color: Color red ].
	aString = 'ChooseColor'
		ifTrue: [ | dialog |
			dialog := self factory colorChooser title: 'Choose color'.
			dialog selectedColor: Color black.
			dialog openModal.
			shape color: dialog selectedColor.
			shape position: 5 @ 5 ].
	pane widget trachelCanvas addShape: shape.
	"Required so that the changed drawing is shown"
	pane widget changed! !

!M2MFrontendDemo methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
factory
	^ factory! !

!M2MFrontendDemo methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
initialize
   super initialize. 
	factory := M2MFactory new! !

!M2MFrontendDemo methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
initializePresenter
	"whenSelectionChangedDo:"
"In Pharo 7: whenSelectionChangedDo:"
	list
		whenSelectionChanged:  [ :item | 
      "The following causes errors in Pharo 7 and appears not to be used in Pharo 5 and 6:"
			"self draw2: item.
			self changeMyTitle: item"	 ]
			
		"	list
		whenSelectionChanged:  [ :selection | 
			[ :item | 
			self draw2: item.
			self changeMyTitle: item	 ]
			
				cull: selection selectedItem ]"! !

!M2MFrontendDemo methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
initializeWidgets
	| windowMorph tRcanvas |
	tRcanvas := TRCanvas new.
	self makeZoomable: tRcanvas.
	self makeCanvasDraggable: tRcanvas.

	"tRcanvas addShape: (TRBoxShape new size: 2)."
	windowMorph := TRMorph new.
	windowMorph canvas: tRcanvas.
	pane := windowMorph asSpecAdapter.
	pane
		when: MorphOpened
		do: [ Transcript
				cr;
				show: 'Opened';
				cr.
			windowMorph extent: 400 @ 400.
			"windowMorph extent: windowMorph extent asIntegerPoint."
			windowMorph changed ].
	pane widget surface
		drawDuring:
			[ :canvas | "First, we clear the surface" "view widget surface clear." "we can use " pane widget surface clear: Color white ].
	pane changed.
	menu := self mainMenu.
	list := self newList.
	list items: {'Green' . 'Red'}.
	self focusOrder add: list! !

!M2MFrontendDemo methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
list
		^ list! !

!M2MFrontendDemo methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
mainMenu
	| aMenu |
	aMenu := MenuModel new"Pharo 7 : self newMenuBar"
		addGroup: [ :group | 
			group
				addItem: [ :item | 
					item
						name: nil;
						description: 'Open Help';
						icon: ( Smalltalk ui icons iconNamed: #help "Replace in Pharo 7 with: self iconNamed:");
						action: [ HelpBrowser openOn: M2MHelp ] ] ];

		addGroup: [ :group | 
			group
				addItem: [ :item | 
					item
						name: nil;
						description: 'Green';
						icon: (Smalltalk ui icons iconNamed: #glamorousGreenCircle);
						action: [ self draw2: #Green ] ] ];
		addGroup: [ :group | 
			group
				addItem: [ :item | 
					item
						name: nil;
						description: 'Red';
						icon: (Smalltalk ui icons iconNamed: #glamorousRedCircle);
						action: [ self draw2: #Red ] ] ];
		addGroup: [ :group | 
			group
				addItem: [ :item | 
					item
						name: nil;
						description: 'White';
						icon: (Smalltalk ui icons iconNamed: #glamorousAdd);
						action: [ self draw2: #ChooseColor ] ] ].
	^ aMenu! !

!M2MFrontendDemo methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
makeCanvasDraggable: aCanvas
	"See class RTDraggableView how this is done
This makes it possible to dragg the pane with the mouse "

	aCanvas
		when: TRMouseDragging
		do: [ :e | 
			aCanvas camera translateBy: e step negated / aCanvas camera scale.
			pane widget changed ]! !

!M2MFrontendDemo methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
makeDraggable: aShape pane: aPane
	"Make element draggable. See class RTDraggableView how this works in prinziple."

	aShape
		when: TRMouseDragging
		do: [ :e | 
			aShape translateBy: e step / aPane widget trachelCanvas camera scale.
			aPane widget changed ]! !

!M2MFrontendDemo methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
makeZoomable: aCanvas
	"See class RTZoomableView how this is done
This makes it possible to scroll with the mouse wheel"

	| maxZoom minZoom |
	maxZoom := 10.
	minZoom := 0.1.
	aCanvas
		when: TRMouseWheelEvent
		do: [ :e | 
			| scale dist |
			dist := e position - aCanvas camera position.
			scale := aCanvas camera scale.
			(e isUp and: [ scale * 1.25 <= maxZoom ])
				ifTrue: [ scale := scale * 1.25.
					dist := dist * 0.2 ]
				ifFalse: [ dist := 0 ].
			(e isDown and: [ scale * 0.8 >= minZoom ])
				ifTrue: [ scale := scale * 0.8.
					dist := dist * -0.25 ]
				ifFalse: [ dist := 0 ].
			aCanvas camera
				scale: scale;
				translateBy: dist.
			"aCanvas signalUpdate."
			pane widget changed ]! !

!M2MFrontendDemo methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
menu
	^ menu! !

!M2MFrontendDemo methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
pane
	^ pane! !

!M2MFrontendDemo methodsFor: 'refreshing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
refresh
	"pane widget resize"! !

!M2MFrontendDemo methodsFor: 'api' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
title
	^ 'Moose2Model'! !

!M2MFrontendDemo methodsFor: 'api-events' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
whenSelectedItemChanged: aBlock
		list whenSelectedItemChanged: aBlock! !

!FAMIXClassGroup methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
generateMoose2ModelDiagramOfMooseModel2: aMooseModel
"Backup of old logic, calls the inspector of the view"
	| aRWDElementGroup diagram view e |
	diagram := RWDiagram new.
	aRWDElementGroup := RWDiagramElementGroup new.
	self
		do: [ :each | 
			| anFElement |
			anFElement := RWDiagramElement famixElement: each.
			aRWDElementGroup add: anFElement ].
	view := diagram
		methodUsage: aRWDElementGroup
		withEditor: RWDiagramEditor uniqueInstance
		withLayout: nil
		 withMondrian: nil
		ofMooseModel: aMooseModel
		test: false.
	view
		ifNil: [ self inform: 'Generation of View aborted due to user request' ]
		ifNotNil: [ view inspect.
			diagram
				readToRTView: view
				withEditor: RWDiagramEditor uniqueInstance
				withLayout: RWDiagramEditor uniqueInstance currentLayout.
				    e := RWDiagramEditor uniqueInstance.
				    e lastUsedView: view ]! !

!FAMIXClassGroup methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
generateMoose2ModelDiagramOfMooseModel: aMooseModel
	| aRWDElementGroup diagram view e |
	diagram := RWDiagram new.
	aRWDElementGroup := RWDiagramElementGroup new.
	self
		do: [ :each | 
			| anFElement |
			anFElement := RWDiagramElement famixElement: each.
			aRWDElementGroup add: anFElement ].
	view := diagram
		methodUsage: aRWDElementGroup
		withEditor: RWDiagramEditor uniqueInstance
		withLayout: nil
		 withMondrian: nil
		ofMooseModel: aMooseModel
		test: false.
	view
		ifNil: [ self inform: 'Generation of View aborted due to user request' ]
		ifNotNil: [ 
			|frontend|
			frontend := M2MFrontend new.
			frontend rtView: view mooseModel: aMooseModel.
			frontend openWithSpec.
			diagram
				readToRTView: view
				withEditor: RWDiagramEditor uniqueInstance
				withLayout: RWDiagramEditor uniqueInstance currentLayout.
				    e := RWDiagramEditor uniqueInstance.
				    e lastUsedView: view.
				^frontend "Return instance to simplify testing" ]! !

!FAMIXClassGroup methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
viewRWDiagramDependencyObsolete
	<menuItem: 'Moose2Model Software Exploration Tool - Use Context Model of Model' category: 'Visualize'>
	self inform: 'Obsolete, use instead the context menu of the models'! !

TestCase subclass: #M2MMainDemoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose2Model-Test'!

!M2MMainDemoTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testSingleColorChoosedBox
	"See class MenuPresenterTest how menus are accessed in test."

	"Create a single green box and test that exactly one shape is created"

	| m2m greenButton |
	m2m := M2MFrontendDemo new.
	m2m factory colorChooser: M2MMockColorSelectorDialogWindow new.
	m2m factory colorChooser mockSelectedColor: Color blue.
	m2m openWithSpec.	"buildWithSpec."
	greenButton := (m2m mainMenu menuGroups
		select: [ :group | group menuItems first description = #White ])
		first menuItems first.
	greenButton performMenuActionWith: {}.
	self assert: m2m pane widget trachelCanvas shapes size equals: 1.
	self
		assert: m2m pane widget trachelCanvas shapes first position
		equals: 5 @ 5.
	self
		assert: m2m pane widget trachelCanvas shapes first color
		equals: Color blue.
	"m2m pane widget trachelCanvas shapes inspect."
	m2m window close	"Not needed when test runs in background"! !

!M2MMainDemoTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testSingleGreenBox
	"See class MenuPresenterTest how menus are accessed in test"

	"Create a single green box and test that exactly one shape is created"

	| m2m greenButton |
	m2m := M2MFrontendDemo new.
	m2m openWithSpec.	"buildWithSpec."
	greenButton := (m2m mainMenu menuGroups
		select: [ :group | group menuItems first description = #Green ])
		first menuItems first.
	greenButton performMenuActionWith: {}.
	self assert: m2m pane widget trachelCanvas shapes size equals: 1.
	self
		assert: m2m pane widget trachelCanvas shapes first position
		equals: 10 @ 10.
	"m2m pane widget trachelCanvas shapes inspect."
	m2m window close	"Not needed when test runs in background"! !

!M2MMainDemoTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testSingleRedBox
	"See class MenuPresenterTest how menus are accessed in test"

	"Create a single red box and test that exactly one shape is created"

	| m2m greenButton |
	m2m := M2MFrontendDemo new.
	m2m openWithSpec.	"buildWithSpec."
	greenButton := (m2m mainMenu menuGroups
		select: [ :group | group menuItems first description = #Red ]) first
		menuItems first.
	greenButton performMenuActionWith: {}.
	self assert: m2m pane widget trachelCanvas shapes size equals: 1.
	self
		assert: m2m pane widget trachelCanvas shapes first position
		equals: 0 @ 0.
	"m2m pane widget trachelCanvas shapes inspect."
	m2m window close	"Not needed when test runs in background"! !

TestCase subclass: #M2MMainSuperclassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose2Model-Test'!

!M2MMainSuperclassTest commentStamp: 'RainerWinkler 8/29/2019 08:58' prior: 0!
This is the main super class for tests in the new namespace. It sets and unsets the flag that automatic tests are active.!

!M2MMainSuperclassTest methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
setUp
	super setUp.
	RWDiagram automaticTestIsRunning: true "Needed to prevent pop ups during tests"! !

!M2MMainSuperclassTest methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
tearDown
	super tearDown.
	RWDiagram automaticTestIsRunning: false! !

M2MMainSuperclassTest subclass: #M2MMainTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose2Model-Test'!

!M2MMainTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
checkNotRestricted: frontend
	| count |
	"Use in an inspector on frontend:
self rtView view elements do:[:each|Transcript show: each model asString; cr ].
to get a list of all elements
self rtView view edges do:[:each|Transcript show: each model asString; cr ].
to get a list of edges"	
	self assert: frontend rtView view elements size equals: 34.
	count := 0.	"Check all elements"
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement package2 (Package)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.	"There has to be at least a single correctly named element"
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement a RWDiagramNoPackage'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement package1 (Package)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class2 (Class)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class2.var1 (Attribute)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class2.var2 (Attribute)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class2>>method2 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class2>>method3 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class2>>methodExt (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement classNopackage (Class)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class1 in Smalltalk (Class)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString
				= 'a RWDiagramElement class1.attributeA0 (Attribute)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class1>>method1 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class1>>methodI0P2 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class1>>methodI0P1 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class1>>methodI0 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class1>>methodI0M1 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class1>>methodI0M2 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class1>>methodA0 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	"The next elements belong to the legend"
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'Class (Grouping level 1)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'Box: Active system component'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'Circle: Passive system component'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'Circle: DataBase Table'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'Access to "Data" resp. attribute'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'Arrow points to used component'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.

	"Check all edges"
	count := 0.
	frontend rtView view edges
		do: [ :each | 
			each model asString
				=
					'a RWDiagramElement class1>>method1 (Method)->a RWDiagramElement class2>>method2 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view edges
		do: [ :each | 
			each model asString
				=
					'a RWDiagramElement class1>>methodI0P2 (Method)->a RWDiagramElement class1>>methodI0P1 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view edges
		do: [ :each | 
			each model asString
				=
					'a RWDiagramElement class1>>methodI0P1 (Method)->a RWDiagramElement class1>>methodI0 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view edges
		do: [ :each | 
			each model asString
				=
					'a RWDiagramElement class1>>methodI0 (Method)->a RWDiagramElement class1>>methodI0M1 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view edges
		do: [ :each | 
			each model asString
				=
					'a RWDiagramElement class1>>methodI0M1 (Method)->a RWDiagramElement class1>>methodI0M2 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view edges
		do: [ :each | 
			each model asString
				=
					'a RWDiagramElement class2>>method3 (Method)->a RWDiagramElement class2>>method2 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view edges
		do: [ :each | 
			each model asString
				=
					'a RWDiagramElement class1>>method1 (Method)->a RWDiagramElement class2.var2 (Attribute)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view edges
		do: [ :each | 
			each model asString
				=
					'a RWDiagramElement class2>>method2 (Method)->a RWDiagramElement class2.var1 (Attribute)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view edges
		do: [ :each | 
			each model asString
				=
					'a RWDiagramElement class1>>methodA0 (Method)->a RWDiagramElement class1.attributeA0 (Attribute)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view edges
		do: [ :each | 
			each model asString
				=
					'a RWDiagramElement class1>>methodI0 (Method)->a RWDiagramElement class1.attributeA0 (Attribute)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
! !

!M2MMainTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
checkRestricted: frontend
	| count |
	"Use in an inspector on frontend:
self rtView view elements do:[:each|Transcript show: each model asString; cr ].
to get a list of all elements
self rtView view edges do:[:each|Transcript show: each model asString; cr ].
to get a list of edges"
	self assert: frontend rtView view elements size equals: 22.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement package1 (Package)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement a RWDiagramNoPackage'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class1 in Smalltalk (Class)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class1.attributeA0 (Attribute)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class1>>methodI0P1 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class1>>methodI0 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'a RWDiagramElement class1>>methodI0M1 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'Class (Grouping level 1)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'Box: Active system component'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'Circle: Passive system component'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'Circle: DataBase Table'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'Access to "Data" resp. attribute'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view elements
		do: [ :each | 
			each model asString = 'Arrow points to used component'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	self assert: frontend rtView view edges size equals: 3.
	count := 0.
	frontend rtView view edges
		do: [ :each | 
			each model asString = 'a RWDiagramElement class1>>methodI0 (Method)->a RWDiagramElement class1>>methodI0M1 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view edges
		do: [ :each | 
			each model asString = 'a RWDiagramElement class1>>methodI0P1 (Method)->a RWDiagramElement class1>>methodI0 (Method)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1.
	count := 0.
	frontend rtView view edges
		do: [ :each | 
			each model asString = 'a RWDiagramElement class1>>methodI0 (Method)->a RWDiagramElement class1.attributeA0 (Attribute)'
				ifTrue: [ count := count + 1 ] ].
	self assert: count equals: 1! !

!M2MMainTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
fronted: frontend element: element DoContextMenu: menuEntry
	frontend rtView view elements
		do: [ :each | 
			each model asString = element
				ifTrue: [ each announcer subscriptions subscriptions
						do: [ :each2 | 
							each2 announcementClass asString = #TRMouseRightClick
								ifTrue: [ each2 subscriber actionsToTestMoose2Model
										do: [ :each3 | 
											each3 key = menuEntry
												ifTrue: [ each3 value cull: each ] ] ] ] ] ]! !

!M2MMainTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
frontend: frontend DoContextMenuOnPane: menuEntry
	frontend rtView view canvas announcer subscriptions subscriptions
		do: [ :each | 
			each announcementClass asString = #TRMouseRightClick
				ifTrue: [ each subscriber actionsToTestMoose2Model
						do: [ :each3 | 
							each3 key = menuEntry
								ifTrue: [ each3 value cull: frontend rtView view ] ] ] ]! !

!M2MMainTest methodsFor: 'tests' stamp: 'RainerWinkler 8/31/2019 13:06'!
makeTestMooseModel
|model package1 package2 namespace class1 class2 method1 method2 method3 var1 var2 var3 methodI0P2 methodI0P1 methodI0 methodI0M1 methodI0M2 methodA0 attributeA0  classNopackage  inh methodExt access acc1 inv1 inv3 ref1 inv0P2 inv0P1 inv0 inv0M1 accI0 accA0 |

	model := MooseModel new.
	
	model name: 'A MooseModel for a Unit Test'.
	
	package1 := FAMIXPackage new name: 'package1'; mooseModel: model.
	package2 := FAMIXPackage new name: 'package2'; mooseModel: model.
	namespace := FAMIXNamespace new name: 'Smalltalk'; mooseModel: model.
	class1 := FAMIXClass new name: 'class1'; parentPackage: package1; container: namespace; mooseModel: model.
	class2 := FAMIXClass new name: 'class2'; parentPackage: package2; mooseModel: model.
	classNopackage := FAMIXClass new name: 'classNopackage'; mooseModel: model.
	inh := FAMIXInheritance new subclass: class1; superclass: class2; mooseModel: model.
	method1 := FAMIXMethod new name: 'method1'; parentType: class1; mooseModel: model; hasClassScope: true.
	method2 := FAMIXMethod new name: 'method2'; parentType: class2; mooseModel: model.
	method3 := FAMIXMethod new name: 'method3'; parentType: class2; mooseModel: model.
	methodExt := FAMIXMethod new name: 'methodExt'; parentType: class2; parentPackage: package1; mooseModel: model.
	var1 := FAMIXAttribute new name: 'var1'; parentType: class2; declaredType: class1; mooseModel: model.
	var2 := FAMIXAttribute new name: 'var2'; parentType: class2; mooseModel: model.
	var3 := FAMIXLocalVariable new name: 'var3'; parentBehaviouralEntity: method2; declaredType: class1; mooseModel: model.
	access := FAMIXAccess new accessor: method1; variable: var2; mooseModel: model.
	acc1 := FAMIXAccess new accessor: method2; variable: var1; mooseModel: model.
	inv1 := FAMIXInvocation new sender: method1; addCandidate: method2; receiver: var2; mooseModel: model.
	"inv2 := FAMIXInvocation new sender: method2; addCandidate: method2; receiver: var2; mooseModel: model."
	inv3 := FAMIXInvocation new sender: method3; addCandidate: method2; receiver: var2; mooseModel: model.
	ref1 := FAMIXReference new source: method1; target: class2; mooseModel: model.
	"Test invocations"
	methodI0P2 := FAMIXMethod new name: 'methodI0P2'; parentType: class1; mooseModel: model.
	methodI0P1 := FAMIXMethod new name: 'methodI0P1'; parentType: class1; mooseModel: model.
	inv0P2 := FAMIXInvocation new sender: methodI0P2; addCandidate: methodI0P1; mooseModel: model.
	methodI0 := FAMIXMethod new name: 'methodI0'; parentType: class1; mooseModel: model; hasClassScope: true.
	inv0P1 := FAMIXInvocation new sender: methodI0P1; addCandidate: methodI0; mooseModel: model.
	methodI0M1 := FAMIXMethod new name: 'methodI0M1'; parentType: class1; mooseModel: model.
	inv0 := FAMIXInvocation new sender: methodI0; addCandidate: methodI0M1; mooseModel: model.
	methodI0M2 := FAMIXMethod new name: 'methodI0M2'; parentType: class1; mooseModel: model.
	inv0M1 := FAMIXInvocation new sender: methodI0M1; addCandidate: methodI0M2; mooseModel: model.
	"Test access to attributes"
	methodA0 := FAMIXMethod new name: 'methodA0'; parentType: class1; mooseModel: model.
	attributeA0 := FAMIXAttribute new name: 'attributeA0'; parentType: class1; mooseModel: model.
	accI0 := FAMIXAccess new accessor: methodI0; variable: attributeA0; mooseModel: model.
	accA0 := FAMIXAccess new accessor: methodA0; variable: attributeA0; mooseModel: model.
	
	"So that printing methods works correctly"
   model allMethods do: [ :m | m signature: m name ].
^model! !

!M2MMainTest methodsFor: 'tests' stamp: 'RainerWinkler 8/31/2019 13:03'!
testFullDisplayOfMooseModel
	"This tests that an explicitely created Moose Model is displayed correctly.
	1. Create a Moosemode
	2. Display it completely in the forntend
	3. Search for a certain method and add it and only neighbours to diagram
	4. Clear the frontend and open the diagram again (Do not read from file but from the remembered informations)
	5. Check that now only a restricted number of elements is shown
	6. Refresh again
	7. Read diagram information from file
	8. Check that the diagram is restricted as specified in the file"
	

	| model frontend |
	model := self makeTestMooseModel.
	model moose2ModelRefresh.
	model moose2ModelSetCurrentLayoutName: 'LayoutUsedByAutomaticTests'.
	frontend := model moose2ModelDependency.
	"Is the title correct?"
	self assert: frontend title equals: 'LayoutUsedByAutomaticTests - A MooseModel for a Unit Test'.
	"Now check the diagram in detail"
	self checkNotRestricted: frontend.

	"Navigate to methodI0 and perform a right mouseclick on 'Add with neighbours'."
	self fronted: frontend element: 'a RWDiagramElement class1>>methodI0 (Method)' DoContextMenu: 'Add with neighbours'.
	"Right click on the pane and remember to file"
	self frontend: frontend DoContextMenuOnPane: 'Remember to file'.
	frontend window close.
	"Display again"
	frontend := model moose2ModelDependency.
	"Check the now restricted diagram"
	self checkRestricted: frontend.
	frontend window close.
	"Now refresh and try to load again from file"
	model moose2ModelRefresh.
	frontend := model moose2ModelReadLayoutExpliciteFile: 'LayoutUsedByAutomaticTests'.
	self checkRestricted: frontend.
	"frontend inspect."
	frontend window close! !

!M2MMainTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testSingleColorChoosedBox
	"See class MenuPresenterTest how menus are accessed in test."

	"Create a single green box and test that exactly one shape is created"

	| m2m greenButton |
	m2m := M2MFrontend new.
	m2m factory colorChooser: M2MMockColorSelectorDialogWindow new.
	m2m factory colorChooser mockSelectedColor: Color blue.
	m2m openWithSpec.	"buildWithSpec."
	greenButton := (m2m mainMenu menuGroups
		select: [ :group | group menuItems first description = #White ])
		first menuItems first.
	greenButton performMenuActionWith: {}.
	self assert: m2m pane widget trachelCanvas shapes size equals: 2. "Expect 2 as there is now also a text in the Window"
	self
		assert: m2m pane widget trachelCanvas shapes second position "The box is the second element"
		equals: 5 @ 5.
	self
		assert: m2m pane widget trachelCanvas shapes second color "The box is the second element"
		equals: Color blue.
	"m2m pane widget trachelCanvas shapes inspect."
	m2m window close	"Not needed when test runs in background"! !

!M2MMainTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testSingleGreenBox
	"See class MenuPresenterTest how menus are accessed in test"

	"Create a single green box and test that exactly one shape is created"

	| m2m greenButton |
	m2m := M2MFrontend new.
	m2m openWithSpec.	"buildWithSpec."
	greenButton := (m2m mainMenu menuGroups
		select: [ :group | group menuItems first description = #Green ])
		first menuItems first.
	greenButton performMenuActionWith: {}.
	self assert: m2m pane widget trachelCanvas shapes size equals: 2. "Expect 2 as there is now also a text in the Window"
	self
		assert: m2m pane widget trachelCanvas shapes second position  "The box is the second element"
		equals: 10 @ 10.
	"m2m pane widget trachelCanvas shapes inspect."
	m2m window close	"Not needed when test runs in background"! !

!M2MMainTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testSingleRedBox
	"See class MenuPresenterTest how menus are accessed in test"

	"Create a single red box and test that exactly one shape is created"

	| m2m greenButton |
	m2m := M2MFrontend new.
	m2m openWithSpec.	"buildWithSpec."
	greenButton := (m2m mainMenu menuGroups
		select: [ :group | group menuItems first description = #Red ]) first
		menuItems first.
	greenButton performMenuActionWith: {}.
	self assert: m2m pane widget trachelCanvas shapes size equals: 2.  "Expect 2 as there is now also a text in the Window"
	self
		assert: m2m pane widget trachelCanvas shapes second position  "The box is the second element"
		equals: 0 @ 0.
	"m2m pane widget trachelCanvas shapes inspect."
	m2m window close	"Not needed when test runs in background"! !

M2MMainSuperclassTest subclass: #M2MMockColorSelectorDialogWindowTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose2Model-Test'!

!M2MMockColorSelectorDialogWindowTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testSimple
	| i |
	i := M2MMockColorSelectorDialogWindow new.
	self assert: (i title: 'My title') isNotNil.
	self assert: i title equals: 'My title'! !

!MooseEntity methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
asRWDiagramElement
"Replace with asRWDiagramElement: aRWDiagramElementGroupOrLayoutOrEditor in most cases"
	^ RWDiagramElement famixElement: self! !

!MooseEntity methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
asRWDiagramElement: aRWDiagramElementGroupOrLayoutOrEditor
	"Replaces a FAMIX Element (Moose Entity) with a RWDiagramElement that has the same attributes a specified in either a RWDiagramEditor, a RWDiagramLayout or a RWDiagramElementGroup"

	| elementGroup |
	aRWDiagramElementGroupOrLayoutOrEditor class = RWDiagramEditor
		ifTrue: [ elementGroup := aRWDiagramElementGroupOrLayoutOrEditor globalElementGroup ]
		ifFalse: [ aRWDiagramElementGroupOrLayoutOrEditor class = RWDiagramLayout
				ifTrue: [ elementGroup := aRWDiagramElementGroupOrLayoutOrEditor elementGroup ]
				ifFalse: [ elementGroup := aRWDiagramElementGroupOrLayoutOrEditor ] ].
	^ elementGroup apply: [ :e | e ] toAttribute: self replace: true! !

!RTMenuActivable methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
actionsToTestMoose2Model
	^actions! !

!FAMIXMethod class methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelName
	^self name! !

!FAMIXMethod methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelAddWithNeighbours
	<menuItem: 'Add with neighbours' category: 'Moose2Model'>
	RWDiagram suppressOthersUsedByLayers: 1 usingLayers: 1 to: self! !

!FAMIXMethod methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelHighlight
	<menuItem: 'Highlight' category: 'Moose2Model'>
	RWDiagram highlightIncludingMe: true usedByLayers: 0 usingLayers: 0 to: self! !

!FAMIXMethod methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelHighlightWithNeighbours
	<menuItem: 'Highlight with neighbours' category: 'Moose2Model'>
	RWDiagram highlightIncludingMe: true usedByLayers: 1 usingLayers: 1 to: self! !

!FAMIXMethod methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelName
	^self name! !

!FAMIXMethod methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelName: aString 
	^self name! !

!FAMIXMethod methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelRemoveAppearanceChangers
	<menuItem: 'Remove from Model (If not added due to other settings)' category: 'Moose2Model'>
	RWDiagram removeAppearanceChangersFrom: self! !

!FAMIXMethod methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelRemoveSuppress
	<menuItem: 'Remove suppress' category: 'Moose2Model'>
	RWDiagram suppressWithChildren: false to: self! !

!FAMIXMethod methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelSuppress
	<menuItem: 'Suppress' category: 'Moose2Model'>
	RWDiagram suppressWithChildren: true to: self! !

!MooseModel methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelDependency
	<menuItem: 'Display diagram' category: 'Moose2Model'>
	|frontend|
	"Supports automatic tests"
	self inform: 'Use "Moose2Model with formatting info" to get a hint on how a diagram is generated'.
	RWDiagramEditor uniqueInstance currentLayout mooseID
		ifNotNil: [ RWDiagramEditor uniqueInstance currentLayout mooseID = self mooseID
				ifFalse: [ self inform: 'Model is changed. Read again from file, to see adaptions'. ^self ] ].
	RWDiagramEditor uniqueInstance settings displayFormatter: false.
	RWDiagramEditor uniqueInstance lastUsedClassGroup: self allClasses.
	frontend := self allClasses generateMoose2ModelDiagramOfMooseModel: self.
	^frontend "Frontend instance is needed in tests"! !

!MooseModel methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelDependencyInfo
	<menuItem: 'Display with formatting info' category: 'Moose2Model'>
	| frontend |
	"Supports automatic tests"
	self
		inform:
			'Elements without appearance changers will be hightlighted. Use to find out where a statement like "RWDiagram suppressOthersUsedByLayers: 1 usingLayers: 1 to: self." is needed.'.
	RWDiagramEditor uniqueInstance currentLayout mooseID
		ifNotNil: [ RWDiagramEditor uniqueInstance currentLayout mooseID = self mooseID
				ifFalse: [ self inform: 'Model is changed. Read again from file, to see adaptions'.
					^ self ] ].
	RWDiagramEditor uniqueInstance settings displayFormatter: true.
	RWDiagramEditor uniqueInstance lastUsedClassGroup: self allClasses.
	frontend := self allClasses generateMoose2ModelDiagramOfMooseModel: self.
	^ frontend	"Frontend instance is needed in tests"! !

!MooseModel methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelInfo
	<menuItem: 'Tools: Info' category: 'Moose2Model'>
	self inform: 'This is version:', RWDiagram new actualVersion.
	self inform: 'Go to Moose2Model.org for help'.! !

!MooseModel methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelName
	^self name! !

!MooseModel methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelOpenSimpleGui
	<menuItem: 'Tools: Open Simple Gui' category: 'Moose2Model'>
	RWDiagramSimpleGui open.! !

!MooseModel methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelReadLayout
	<menuItem: 'Read Layout from path and display' category: 'Moose2Model'>
	"Supports automatic tests"
	self moose2ModelReadLayoutExpliciteFile: nil

! !

!MooseModel methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelReadLayoutExpliciteFile: aFilename
	| layout layouts index frontend |
	"Supports automatic tests"
	layouts := RWDiagramLayoutManager new layoutsOfCurrentPath.
	aFilename ifNil: [ index := UIManager default chooseFrom: layouts ] ifNotNil: [ index := layouts indexOf: aFilename ].
	index > 0
		ifTrue: [ layout := layouts at: index.
			RWDiagram readLayout: layout ofMooseModel: self expliciteStream: nil.
			self inform: 'Read layout:' , layout.
			frontend := self moose2ModelDependency.
			^ frontend	"Required for automatic tests" ]
		ifFalse: [ ^ nil	"This is not beautiful, but it makes the actual logic more explicite so return nil" ]! !

!MooseModel methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelRefresh
	<menuItem: 'Refresh (Clears all settings)' category: 'Moose2Model'>
	self inform: 'All informations are cleared (except the path). Set or read layout again.'.
	RWDiagram refresh.! !

!MooseModel methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelRememberLastUsedLayout
	<menuItem: 'Remember last used Layout to file' category: 'Moose2Model'>
	RWDiagram rememberLastUsedDiagram.
	self inform: 'Last used Layout is saved to file'.
	RWDiagramEditor uniqueInstance lastUsedClassGroup: self! !

!MooseModel methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelRemoveTemporary
	<menuItem: 'Clear highlighting' category: 'Moose2Model'>
	RWDiagram removeTemporary! !

!MooseModel methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelSetClassScope
	<menuItem: 'Set mode to display classes and packages' category: 'Moose2Model'>
	RWDiagram setClassScope! !

!MooseModel methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelSetCurrent
	<menuItem: 'Set current' category: 'Moose2Model'>
	self inform: 'Call RWDiagram drawDiagram. or RWDiagram drawDiagramWithFormattingInfo. to display a diagram'.
	RWDiagramEditor uniqueInstance lastUsedClassGroup: self! !

!MooseModel methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelSetCurrentLayoutName
	<menuItem: 'Set new Layout name' category: 'Moose2Model'>
	| layout |
	layout := UIManager default request: 'Specify new name for a layout'.
	layout ifNotNil:
		[ self moose2ModelSetCurrentLayoutName: layout ]! !

!MooseModel methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelSetCurrentLayoutName: layout
   "Will be called separately in Unit Tests"
	RWDiagram currentLayoutName: layout.
	self inform: 'New Layout Name' , layout.
	^ RWDiagramEditor uniqueInstance lastUsedClassGroup: self! !

!MooseModel methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelSetMethodScope
	<menuItem: 'Set mode to display methods, attributes, classes and packages (Default)' category: 'Moose2Model'>
	RWDiagram setMethodScope! !

!MooseModel methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelSetPackageScope
	<menuItem: 'Set mode to display only packages' category: 'Moose2Model'>
	RWDiagram setPackageScope ! !

!MooseModel methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelSetPath
	<menuItem: 'Set path to Layouts' category: 'Moose2Model'>
	| path |
	path := UIManager default request: 'Specify path where layouts are stored' initialAnswer: RWDiagram path.
	path
		ifNotNil: [ RWDiagram setPath: path.
			self inform: 'New path' , path ]! !

!FAMIXPackage class methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelName
	^self name! !

!FAMIXPackage methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelName
	^self name! !

!FAMIXPackage methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelRemoveSuppress
	<menuItem: 'Remove suppress' category: 'Moose2Model'>
	RWDiagram suppressWithChildren: false to: self! !

!FAMIXPackage methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelSuppress
	<menuItem: 'Suppress' category: 'Moose2Model'>
	RWDiagram suppressWithChildren: true to: self! !

CustomHelp subclass: #M2MHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose2Model-Help'!

!M2MHelp commentStamp: 'RainerWinkler 8/2/2019 15:38' prior: 0!
I contain the top chapter of the documentation.!

!M2MHelp class methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
bookDescription
	^ 'Help for the tool to display software systems like a circuit diagram'! !

!M2MHelp class methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
bookName
	"Returns the name of the custom help book"
	
	^'Moose2Model'! !

!M2MHelp class methodsFor: 'accessing' stamp: 'RainerWinkler 12/18/2020 14:38'!
firstSteps
	^ HelpTopic
		title: 'First Steps'
		contents:
			'Open the Moose Panel and import an mse file.
Do a right click of an imported model to get access to the menu of Moose2Model.
You might open the Simple Gui to get some informations.
You might set an alternative path to store and read diagram informations. 
Specify a new diagram name (Otherwise you use a default name).
Select elements of a FAMIX model to add elements to a diagram. This will only work for some elements (Mostly packages, classes, attributes and methods).
Draw a diagram.
Rearange elements as needed. Do a right mouse click to see what is possible. Click on the background to reposition the diagram. Use the scroll wheel of the mouse to zoom in and out.
Redraw when needed.
Store diagram informations to a file. You may use these later, when the application changed to draw actual diagrams even though the coding changed.

When the mse file is extracted with SAP2Moose from an SAP system, Moose2Model will probably work well.
When you analyze Smalltalk you may be required to run Moose2Model on an old Pharo 6 version with old coding.
In all other cases, please try and open an issue.

Go to Moose2Model.org to ask for help and get support.'! !

!M2MHelp class methodsFor: 'accessing' stamp: 'RainerWinkler 12/17/2020 09:17'!
intro
	^ HelpTopic
		title: 'Introduction'
		contents:
			'Moose2Model is a tool to create and maintain circuit diagrams for software.

Go to Moose2Model.org for the actual version.'! !

!M2MHelp class methodsFor: 'accessing' stamp: 'RainerWinkler 12/18/2020 14:26'!
pages
	^ #(intro firstSteps)! !

Object subclass: #M2MFactory
	instanceVariableNames: 'colorChooser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose2Model-Frontend'!

!M2MFactory commentStamp: 'RainerWinkler 8/2/2019 15:38' prior: 0!
I provide instances that may be replaced during tests.
I am responsible for storing instances provided by tests and I instanciate them for productive usage. I may or may not keep a unique instance of an instance I instanciated.
My setter methods are called by tests. My getters are called in the coding to support mock instances in tests.!

!M2MFactory methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
colorChooser
  "I return a mock instanace during tests.
In all other cases I return always a new instance"
	colorChooser
		ifNil: [ ^ ColorSelectorDialogWindow new ]
		ifNotNil: [ ^ colorChooser ]! !

!M2MFactory methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
colorChooser: aColorSelectorDialogWindow
"Use me to provide a mock instance when needed during tests"
	colorChooser := aColorSelectorDialogWindow! !

Object subclass: #M2MFrontendEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose2Model-Frontend'!

!M2MFrontendEntry commentStamp: 'RainerWinkler 8/2/2019 15:38' prior: 0!
I am the entry point of the application.
I define the World menu entries.!

!M2MFrontendEntry class methodsFor: 'world menu' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
menuCommandOn: aBuilder
	"Make entry in the World Menu"

	<worldMenu>
	aBuilder item: #Moose2Model.
	aBuilder withSeparatorAfter.
	(aBuilder
		item: #Moose2Model;
		parent: #Moose2Model) action: [ M2MFrontend new openWithSpec ].
	(aBuilder
		item: #Moose2ModelDemo;
		parent: #Moose2Model) action: [ M2MFrontendDemo new openWithSpec ].
	(aBuilder
		item: #Documentation;
		parent: #Moose2Model) action: [ HelpBrowser openOn: M2MHelp ].
	! !

!Object methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelName
	^self asString! !

ColorSelectorDialogWindow subclass: #M2MMockColorSelectorDialogWindow
	instanceVariableNames: 'mockSelectedColor mockTitle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose2Model-Mocks'!

!M2MMockColorSelectorDialogWindow methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
initialize
^self! !

!M2MMockColorSelectorDialogWindow methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
mockSelectedColor: aColor
	"Preset expected user input"

	mockSelectedColor := aColor! !

!M2MMockColorSelectorDialogWindow methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
openModal
"Do nothing if mocked"
^self! !

!M2MMockColorSelectorDialogWindow methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
selectedColor
	"Mock returning user input"

	^ mockSelectedColor! !

!M2MMockColorSelectorDialogWindow methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
selectedColor: aColor
	"Mock returning user input"

	^ self! !

!M2MMockColorSelectorDialogWindow methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
title


	^mockTitle ! !

!M2MMockColorSelectorDialogWindow methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
title: aMockString
	"Mock returning user input"

	mockTitle := aMockString! !

!FAMIXAttribute class methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelName
	^self name! !

!FAMIXAttribute methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelAddWithNeighbours
	<menuItem: 'Add with neighbours' category: 'Moose2Model'>
	RWDiagram suppressOthersUsedByLayers: 1 usingLayers: 1 to: self! !

!FAMIXAttribute methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelHighlight
	<menuItem: 'Highlight' category: 'Moose2Model'>
	RWDiagram highlightIncludingMe: true usedByLayers: 0 usingLayers: 0 to: self! !

!FAMIXAttribute methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelHighlightWithNeighbours
	<menuItem: 'Highlight with neighbours' category: 'Moose2Model'>
	RWDiagram highlightIncludingMe: true usedByLayers: 1 usingLayers: 1 to: self! !

!FAMIXAttribute methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelName
	^self name! !

!FAMIXAttribute methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelName: aString 
	^self name! !

!FAMIXAttribute methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelRemoveAppearanceChangers
	<menuItem: 'Remove from Model (If not added due to other settings)' category: 'Moose2Model'>
	RWDiagram removeAppearanceChangersFrom: self! !

!FAMIXAttribute methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelRemoveSuppress
	<menuItem: 'Remove suppress' category: 'Moose2Model'>
	RWDiagram suppressWithChildren: false to: self! !

!FAMIXAttribute methodsFor: '*Moose2Model' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelSuppress
	<menuItem: 'Suppress' category: 'Moose2Model'>
	RWDiagram suppressWithChildren: true to: self! !
